#pragma once


enum HttpRequestType
{
	HttpGet = 0,
	HttpPost,
};
//ö״̬
enum DownloadState
{
	HttpLoading = 0,
	HttpFialed,
	HttpFinished,
};

/******************************************************
*Ϣ
*
******************************************************/
enum HttpInterfaceError
{
	HttpErrorSuccess = 0,		//ɹ
	HttpErrorInit,				//ʼʧ
	HttpErrorConnect,			//HTTPʧ
	HttpErrorSend,				//ʧ
	HttpErrorQuery,				//ѯHTTPͷʧ
	HttpError404,				//ҳ治
	HttpErrorIllegalUrl,		//ЧURL
	HttpErrorCreateFile,		//ļʧ
	HttpErrorDownload,			//ʧ
	HttpErrorQueryIP,			//ȡӦĵַʧ
	HttpErrorSocket,			//׽ִ
	HttpErrorUserCancel,		//ûȡ
	HttpErrorBuffer,			//ļ̫󣬻
	HttpErrorHeader,			//HTTPͷ
	HttpErrorParam,				//󣬿ָ룬ַ
	HttpErrorWriteFile,			//дļʧ
	HttpErrorUnknow,			//δ֪

};
//صĻص
class IHttpCallback
{
public:
	virtual void	OnDownloadCallback(void* pParam, DownloadState state, double nTotalSize, double nLoadSize) = 0;
	virtual bool	IsNeedStop() = 0;
};
//ÿζȡݵĻС 4KB
#define READ_BUFFER_SIZE		4096

//ڴõĻС 8M
#define DOWNLOAD_BUFFER_SIZE	(8*1024*1024)

//صϢ
struct HttpParamsData
{
	void* lpparam;//Զ
	IHttpCallback* callback;//ص
	HttpInterfaceError errcode;//
};


//峣httpͷ
#define HEADER_USER_AGENT			"User-Agent"
#define HEADER_CONNECTION			"Connection"
#define HEADER_ACCEPT				"Accept"
#define HEADER_ACCEPT_ENCODING		"Accept-Encoding"
#define HEADER_ACCEPT_LANGUAGE		"Accept-Language"
#define HEADER_CONTENT_TYPE			"Content-Type"
#define HEADER_HOST					"Host"
#define HEADER_RANGE				"Range"
#define HEADER_LOCATION				"Location"
#define HEADER_CONTENT_LENGTH		"Content-Length"


//ĬHTTP汾
static const char default_http_version[] = "HTTP/1.1";

//ĬϵuserAgent
static const char default_user_agent[] = "Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/80.0.4044.92 Safari/537.36";

//ĬϽ
static const char default_accept[] = "*/*";

//Ĭϱ
static const char default_connection[] = "Keep-Alive";

//Ĭ
static const char default_language[] = "zh-CN,zh;q=0.9";

//HTTPЭ黻з
static const char http_newline[] = "\r\n";
